﻿Imports System.Runtime.CompilerServices

Interface Flugzeug

End Interface

<HideModuleName()> _
Module mdlFlugzeug
    <Extension()> _
    Sub Fliegen(Of T As Flugzeug)(ByVal Flugzeug As T)
        Console.WriteLine("Ich fliege")
    End Sub
End Module

Interface Auto
    Property Name() As String
End Interface

<HideModuleName()> _
Module mdlAuto
    <Extension()> _
    Sub Fahren(Of T As Auto)(ByVal Auto As T)
        Console.WriteLine("Ich fahre")
    End Sub

    <Extension()> _
    Sub ZeigeModellname(Of T As Auto)(ByVal Auto As T)
        Console.WriteLine("Mein Modellname lautet: {0}", Auto.Name)
    End Sub
End Module

Class FlugAuto : Implements Auto, Flugzeug
    Private mName As String

    Public Sub New(ByVal tmpName As String)
        Name = tmpName
    End Sub

    Property Name() As String Implements Auto.Name
        Get
            Return mName
        End Get
        Set(ByVal value As String)
            mName = value
        End Set
    End Property
End Class

Module Module1

    Sub Main()
        Dim FlugAuto As New FlugAuto("SuperFlugauto")

        FlugAuto.Fahren()
        FlugAuto.Fliegen()
        FlugAuto.ZeigeModellname()

        Dim Auto As Auto = FlugAuto
        Dim Flugzeug As Flugzeug = FlugAuto

        Auto.Fahren()
        Flugzeug.Fliegen()

        Console.ReadKey()

    End Sub

End Module
